# -*- mode: rpm-spec; coding: utf-8 -*-
Name: udev_static-complete
Version: 0.0.1
Release: alt1

Summary: A complete set of static device nodes suitable for virtual /dev filesystem
Summary(ru_RU.UTF-8): Полный набор статических файлов устройств, пригодный для виртуальной файловой системы /dev
License: GPL
Group: System/Configuration/Hardware
Url: https://bugzilla.altlinux.org/show_bug.cgi?id=6296
Provides: udev_static = %version-%release
BuildArch: noarch

Source0: %name-%version.cpio.bz2

%description
udev_static is a package complement to udev. While udev itself deals mostly with dynamically created
devices nodes, its approach is not always suitable for real-life usage. In particular, pure udev
system is not able to load an appropriate module when a program accesses corresponding device node,
because this device node simply doesn't exist if the module hasn't been loaded yet. 

modules_lookup tries to make up for this deficiency by intercepting attempts to access yet
amissing device nodes and load associated modules before. Unfortunately it requires a patched
version of tmpfs and still doesn't cover all possible cases

recent udev packages (>= 0.50-alt3) support /etc/udev/devices/ subdirectory where system
administrators can create "preconfigured" device nodes which will be copied to /dev upon
udev daemon startup. But this approach when applied thoughtlessly can use a lot of space right
in root partition.

udev_static provides a compressed cpio archive which contains devices inodes to create
upon udevd startup similar to /etc/udev/devices. But because of the form chosen (compressed
cpio archive) even entire contents of old static dev package takes about 90Kb of disk space.

This package contains an almost complete snapshot of /dev system excluding devices which
_exactly_ are handled by hotplug or other standard subsystems

%description -l ru_RU.UTF-8
udev_static - это пакет, дополняющий udev. В то время как udev сам по себе предназначен,
в основном, для обработки динамически создаваемых файлов устройств, его подход не всегда
приемлем в реальной жизни. В частности, система с одним только udev не в состоянии
загружать требуемый модуль, когда какая-либо программа пытается открыть файл устройства,
т.к. данного файла устройства не существует до загрузки соответствующего модуля.

modules_lookup пытается исправить этот недочет, перехватывая обращения к еще не созданным
файлам устройств и загружая ассоциированные с этими файлами ядерные модули. К сожалению, данный
подход требует наличия патченной версии tmpfs, и по-прежнему не покрывает всех возможных
случаев.

Свежие версии пакета udev (>= 0.50-alt3) поддерживают каталог /etc/udev/devices, где администратор
системы может создать "сконфигуренные заранее" файлы устройств, которые будут скопированны
в /dev при старте демона udev. Однако данный подход, будучи применен бездумно, расходует много
дискового пространства в рутовом разделе.

udev_static предоставляет сжатый архив cpio, в котором содержатся файлы устройств, которые
необходимо создать при старте демона udev, подобно подходу с /etc/udev/devices/. Однако выбранная
форма хранения списка таких устройств (сжатый архив cpio) позволяет существенно снизить расход
дискового пространства: даже все содержимое, соответствующее полному пакету dev, занимает менее
90Kb дискового пространства.

Данный пакет содержит полный набор файлов устройств за исключением тех, которые _наверняка_
корректно обрабатываются в данный момент подсистемой hotplug и другими стандартными подсистемами.

%prep

%install
%__mkdir_p %buildroot%_sysconfdir/udev
install -m 0644 %SOURCE0 %buildroot%_sysconfdir/udev/static_devices.cpio.bz2

%files
%config(noreplace, missingok) %_sysconfdir/udev/static_devices.cpio.bz2

%changelog
* Sat Mar 26 2005 Alexey Morozov <morozov@altlinux.org> 0.0.1-alt1
- Initial build.


